/************************************************************************
/* Dial Demo for CE .Net
 * 
 * 1. "Allow unsafe Code Blocks" option must be set to TRUE in project properties
 * 
************************************************************************/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Threading;
using System.Reflection;
using System.Resources;
using Microsoft.Win32;
using Power3GNet;
using System.IO.Ports;
using System.Threading;
using PACNET;

namespace DialDemo
{
	public partial class Form1 : Form
	{
        String FilePath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetName().CodeBase);
        String DialConfigPath;  // Dialup parameter configure
        String ConfigName = "dial_config.ini";

        StreamReader InitConfig;
		IntPtr rc;                           // connection handle   
 
        #region ޥcoredll
        
        [DllImport("coredll.dll", CharSet = CharSet.Unicode)]
        internal static extern UInt32 RasEnumConnections([In, Out] _RASCONN[] lprasconn, ref UInt32 lpcb, ref UInt32 lpcConnections);

        const int RAS_MaxEntryName = 20;
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        internal struct _RASCONN
        {
            private UInt32 m_size;
            private IntPtr m_hrasconn;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = RAS_MaxEntryName + 1)]
            public char[] m_entryName;

            public IntPtr ConnectionHandle { get { return m_hrasconn; } }
            public string EntryName { get { return new string(m_entryName).TrimEnd(new char[] { '\0' }); } }

            public static _RASCONN CreateStruct()
            {
                _RASCONN obj = new _RASCONN();
                obj.m_size = System.Convert.ToUInt32(Marshal.SizeOf(typeof(_RASCONN)));
                obj.m_hrasconn = IntPtr.Zero;
                obj.m_entryName = new char[RAS_MaxEntryName + 1];
                return obj;
            }
        }
        #endregion
      
		//== Rasdial lib. from coredll.dll ==
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        private struct RASCONNW
        {
            public IntPtr dwSize;
            public IntPtr hrasconn;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 21)]
            public String szEntryName;
        }

        //[DllImport("coredll.dll", EntryPoint = "RasEnumConnections")]
        //public static extern uint RasEnumConnections(ref RASCONNW lprasconn, IntPtr lpcb, IntPtr lpcConnections);

		[DllImport("coredll.dll", EntryPoint = "RasDial")]
		public static extern uint RasDial(IntPtr dialExtensions, IntPtr phoneBookPath,
			IntPtr rasDialParam, uint NotifierType, IntPtr notifier, ref IntPtr pRasConn);
        
		[DllImport("coredll.dll", EntryPoint = "RasHangUp")]
		public static extern uint RasHangUp(IntPtr pRasConn);

        [DllImport("iphlpapi.dll", EntryPoint = "IcmpSendEcho")]       
     	public static extern uint IcmpSendEcho();        

		unsafe public static uint myRasDial(string EntryName, string UserName, string Password, out IntPtr RasConn)
		{
			//EntryName ,UserName,Password - same as in RASDIALPARAMS structure (see MSDN)
			uint r = 0;
			RasConn = IntPtr.Zero;
			byte[] bRASDIALPARAMS = new byte[1464];
            int i = 0;
            for (i = 0; i < 1460; i++) bRASDIALPARAMS[0] = 0;

                fixed (byte* pAddr = bRASDIALPARAMS)
                {
                    byte* pCurrent = pAddr;
                    Marshal.WriteInt32((IntPtr)pCurrent, bRASDIALPARAMS.Length);
                    pCurrent += 4;
                    foreach (byte b in Encoding.Unicode.GetBytes(EntryName))
                    {
                        Marshal.WriteByte((IntPtr)pCurrent, b);
                        pCurrent++;
                    }
                    pCurrent = pAddr + 0x192;//0x192 - offset for RASDIALPARAMS.UserName
                    foreach (byte b in Encoding.Unicode.GetBytes(UserName))
                    {
                        Marshal.WriteByte((IntPtr)pCurrent, b);
                        pCurrent++;
                    }
                    pCurrent = pAddr + 0x394;//0x394 - offset for RASDIALPARAMS.Password
                    foreach (byte b in Encoding.Unicode.GetBytes(Password))
                    {
                        Marshal.WriteByte((IntPtr)pCurrent, b);
                        pCurrent++;
                    }
                    r = RasDial(IntPtr.Zero, IntPtr.Zero, (IntPtr)pAddr, 0xFFFFFFFF, IntPtr.Zero, ref RasConn);
                }

            //GC.Collect();
            //GC.ReRegisterForFinalize(bRASDIALPARAMS);
            //GC.SuppressFinalize(RasConn); 
			return r;
		}

        //Ping Code

        #region Ping via iphlpapi.dll
        [DllImport("\\windows\\iphlpapi.dll", SetLastError = true)]
        static extern IntPtr IcmpCreateFile();

        [DllImport("\\windows\\iphlpapi.dll", SetLastError = true)]
        static extern bool IcmpCloseHandle(IntPtr handle);

        [DllImport("\\windows\\iphlpapi.dll", SetLastError = true)]
        static extern Int32 IcmpSendEcho(IntPtr icmpHandle, Int32 destinationAddress, String requestData, Int16 requestSize, ref IP_OPTION_INFORMATION requestOptions, ref ICMP_ECHO_REPLY replyBuffer, Int32 replySize, Int32 timeout);

        [StructLayout(LayoutKind.Sequential)]
        public struct IP_OPTION_INFORMATION
        {
            public byte TTL;
            public byte TOS;
            public byte Flags;
            public byte OptionsSize;
            public IntPtr OptionsData;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        private struct ICMP_ECHO_REPLY
        {
            public int Address;
            public int Status;
            public int RoundTripTime;
            public Int16 DataSize;
            public Int16 Reserved;
            public IntPtr DataPtr;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 250)]
            public String Data;
            public IP_OPTION_INFORMATION Options;
        }

        //Ping禡
        public int ping(string ip, int timeout)
        {
            //IPEndPoint host = new IPEndPoint(Dns.GetHostEntry(ip).AddressList[0], 0);
            //if (host == null | Environment.OSVersion.Platform != PlatformID.WinCE)
            //{               
            //    return -1;
            //}

            IntPtr ICMPHandle;
            String sData;
            int iReplies;
            IP_OPTION_INFORMATION oICMPOptions = new IP_OPTION_INFORMATION();
            ICMP_ECHO_REPLY ICMPReply = new ICMP_ECHO_REPLY();            
            ICMPHandle = IcmpCreateFile();
            IPAddress aa = IPAddress.Parse(ip);
            Int32 iIP = BitConverter.ToInt32(aa.GetAddressBytes(), 0);
            sData = "01234567890123456789012345678901";
            oICMPOptions.TTL = 255;

            iReplies = IcmpSendEcho(ICMPHandle, iIP, sData, (Int16)sData.Length, ref oICMPOptions, ref ICMPReply, Marshal.SizeOf(ICMPReply), timeout);
                      
            IcmpCloseHandle(ICMPHandle);

            GC.Collect();
            GC.SuppressFinalize(ICMPHandle);
            GC.SuppressFinalize(oICMPOptions);
            GC.SuppressFinalize(ICMPReply); 

            return iReplies;
        }
        #endregion

        [DllImport("wininet.dll")]
        public extern static bool InternetGetConnectedState(out int connectionDescription, int reservedValue);

        //C|Ҧwsu
        private static _RASCONN[] EnumerateConnections()
        {
            _RASCONN[] rasconn;
            UInt32 size = 0, noelements = 0;
            size = System.Convert.ToUInt32(Marshal.SizeOf((rasconn = new _RASCONN[1])[0] = _RASCONN.CreateStruct()));
            if (RasEnumConnections(rasconn, ref size, ref noelements) != 0x00)
            {
                size = System.Convert.ToUInt32(Marshal.SizeOf((rasconn = new _RASCONN[size / Marshal.SizeOf(typeof(_RASCONN))])[0] = _RASCONN.CreateStruct()) * rasconn.Length);
                if (RasEnumConnections(rasconn, ref size, ref noelements) != 0x00) { rasconn = null; }
            }
            return rasconn;
        }

        //_su(קKPortBQڪA)
        public static void DisConnectAll()
        {
            _RASCONN[] ran = EnumerateConnections();
            for (int i = 0; i < ran.Length; i++)
            {
                RasHangUp(ran[i].ConnectionHandle);
            }

        }

        //_su(קKPortBQڪA)
        public static bool disConnect(string mEntryName)
        {
            _RASCONN[] ran = EnumerateConnections();
            for (int i = 0; i < ran.Length; i++)
            {
                if (ran[i].EntryName == mEntryName)
                {
                    if (RasHangUp(ran[i].ConnectionHandle) == 0)
                        return true;
                    else
                        return false;
                }
            }
            return false;   //??
        }

        public Form1()
        {
            InitializeComponent();
        }
        SerialPort comPort = new SerialPort();
        private string endChr = "\r";
        private string sCmd = "";
        //Ras Dial-up
		private void button1_Click(object sender, EventArgs e)
		{
            /////////////////////////////////////////////////////////////////o3G/4GTj
            comPort.BaudRate = 115200;
            comPort.DataBits = 8;
            comPort.Parity = Parity.None;
            comPort.StopBits = StopBits.One;
            comPort.PortName = "COM9";
            try
            {
                comPort.Open();
                sCmd = "AT+CSQ" + endChr;//Send GPS RMC command
                SendStringToCOM(sCmd);
            }
            catch (Exception eee) { }
            timer1.Interval = 10000;
            timer1.Enabled = true;//ҰʰTjקspɾ
            /////////////////////////////////////////////////////////////////
            if (HW_CONNNAME.Text == "" || HW_PING.Text == "")
            {
                txtStatus.Text = "Please input Connection or Ping IP";
            }
            else
            {
                //Ѽܼ
                PingIP = HW_PING.Text;                      //Ping@IP Address
                RasName = HW_CONNNAME.Text;      //W
                RasAccount = HW_USE.Text;                //ϥΪ̱b
                RasPassword = HW_PWR.Text;              //ϥΪ̱KX

                //Disable@Ǥ
                button1.Enabled = false;                     //{ǱҰ
                button3.Enabled = false;                     //xsɮ
                HW_CONNNAME.Enabled = false;    //W
                HW_USE.Enabled = false;                  //ϥΪ̱b
                HW_PWR.Enabled = false;                 //ϥΪ̱KX

                //D{
                ProcessTm.Enabled = true;                      //Ұʭpɾ

                //@wn[:
                //ѨMIcmpSendEcho()|ymemory leakD
                IntPtr ICMPHandle = IcmpCreateFile();
            }                  
    	}

        //Ras Hang-up
		private void button2_Click(object sender, EventArgs e)
		{
            timer1.Enabled = false;//Tjקspɾ
            //D{ǭpɾ
            ProcessTm.Enabled = false;
            mainStep = 0;        //D{ǨBJ^0

            //YB󼷸A,,קKUɥdbOpening Port
            if (IsDialup)
            {
                RasHangUp(rc);
                IsDialup = false;                  //B󼷸ѪA
            }

            //Enabled@Ǥ
            button1.Enabled = true;                     //{ǱҰ
            button3.Enabled = true;                     //xsɮ
            HW_CONNNAME.Enabled = true;    //W
            HW_USE.Enabled = true;                  //ϥΪ̱b
            HW_PWR.Enabled = true;                 //ϥΪ̱KX
            txtStatus.Text = "";                           //MܸT 
            
		}
        
        private void Form1_Load(object sender, EventArgs e)
        {
            comPort.DataReceived += new SerialDataReceivedEventHandler(port_DataReceived);
            //Ū]w
            DialConfigPath = Path.Combine(FilePath, ConfigName);
            FileInfo DialConfig = new FileInfo(DialConfigPath);
            try
            {
                if (DialConfig.Exists)
                {
                    InitConfig = new StreamReader(DialConfigPath);
                    //HW_SLOTNUM.Value = Convert.ToUInt32(InitConfig.ReadLine());
                    HW_CONNNAME.Text = InitConfig.ReadLine();
                    HW_USE.Text = InitConfig.ReadLine();
                    HW_PWR.Text = InitConfig.ReadLine();
                    HW_PING.Text = InitConfig.ReadLine();
                    FAILLIMIT.Value = Convert.ToUInt32(InitConfig.ReadLine());
                    PINGNUM.Value = Convert.ToInt32(InitConfig.ReadLine());

                    //if (InitConfig.ReadLine() == "1")
                    //    SaveLog.Checked = true;
                    //else
                    //    SaveLog.Checked = false;

                    if (InitConfig.ReadLine() == "1")
                        NOTPW.Checked = true;
                    else
                        NOTPW.Checked = false;

                    InitConfig.Close();
                    button1_Click(sender, e);
                }
                else
                {
                    HW_USE.Text = "guest";
                    HW_PWR.Text = "guest";
                    HW_PING.Text = "211.76.107.24";
                    HW_CONNNAME.Text = "My Connection";
                    FAILLIMIT.Value = 10;
                    PINGNUM.Value = 5;
                    //SaveLog.Checked = false;
                    NOTPW.Checked = false;
                }
                txtStatus.Text = "";
            }
            catch (System.Exception e1)
            {
                txtStatus.Text = "file format fail";
                if (DialConfig.Exists)
                    InitConfig.Close();
            }
        }

        //xs]w
        private void button3_Click(object sender, EventArgs e)
        {

            FileInfo ConfigFile = new FileInfo(DialConfigPath);
            StreamWriter SaveConfig = new StreamWriter(DialConfigPath);

            if (!ConfigFile.Exists)
            {
                ConfigFile.Create();
            }

            //SaveConfig.WriteLine(HW_SLOTNUM.Value.ToString());
            SaveConfig.WriteLine(HW_CONNNAME.Text);
            SaveConfig.WriteLine(HW_USE.Text);
            SaveConfig.WriteLine(HW_PWR.Text);
            SaveConfig.WriteLine(HW_PING.Text);
            SaveConfig.WriteLine(FAILLIMIT.Value.ToString());
            SaveConfig.WriteLine(PINGNUM.Value.ToString());

            //if (SaveLog.Checked == true)
            //    SaveConfig.WriteLine("1");
            //else
            //    SaveConfig.WriteLine("0");            

            if (NOTPW.Checked == true)
                SaveConfig.WriteLine("1");
            else
                SaveConfig.WriteLine("0");

            SaveConfig.Close();
        }

        private void NOTPW_CheckStateChanged(object sender, EventArgs e)
        {
            if (NOTPW.Checked == true)
            {
                HW_USE.Text = "";
                HW_USE.Enabled = false;
                HW_PWR.Text = "";
                HW_PWR.Enabled = false;
            }
            else
            {
                HW_USE.Enabled = true;
                HW_PWR.Enabled = true;
            }
        }     

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            //button2_Click(sender, e);
            //D{ǭpɾ
            ProcessTm.Enabled = false;
            mainStep = 0;        //D{ǨBJ^0

            //YB󼷸A,,קKUɥdbOpening Port
            if (IsDialup)
            {
                RasHangUp(rc);
                IsDialup = false;                  //B󼷸ѪA
            }

            //Enabled@Ǥ
            button1.Enabled = true;                     //{ǱҰ
            button3.Enabled = true;                     //xsɮ
            HW_CONNNAME.Enabled = true;    //W
            HW_USE.Enabled = true;                  //ϥΪ̱b
            HW_PWR.Enabled = true;                 //ϥΪ̱KX
        }

        //--------------------------alung--------------------------------------
        UInt32 mainStep=4;                   //D{
        UInt32 rst3GStep = 0;                //Reset 3GҲժ{
        UInt32 COM1_failNum=0;         //COM1
        UInt32 Ping_failNum = 0;          //PingѪ
        UInt32 Ping_successNum = 0;     //Ping\
        UInt32 RasDailup_failNum = 0;  //Ѧ
        bool IsDialup=false;                   //B󼷸A
        int PingState = 0;                       //Ping@ӦmG
        uint RasDialupState = 0;             //G
        string PingIP = "8.8.8.8";           //Ping@IP Address
        string RasName = "U200";          //W
        string RasAccount = "";              //ϥΪ̱b
        string RasPassword = "";             //ϥΪ̱KX
        
        private void ProcessTm_Tick(object sender, EventArgs e)
        {
            ProcessTm.Enabled = false;

            switch(mainStep)
            {
                case 0:   //ˬdCOM1O_sb mark by tunglu->ˬdCOM1SNqAӭnˬdqTCOM portASLkqsu]woثeCOM portXAҥH

                    //if (Power3GNet.Power3GNet.pac_Detect3G())  //COM1sb
                    if (true)  //COM1sb
                    {
                        //txtStatus.Text = "COM1 is OK";
                        if (IsDialup)  //|\
                            mainStep = 2;    //iPingʧ@                        
                        else
                            mainStep = 4;    //i漷ʧ@
                    }
                    else
                    {    
                        COM1_failNum++;     //COM1쪺+1                      
                        if (COM1_failNum > 10)
                        {
                            txtStatus.Text = "Reset System";
                            mainStep = 99;             //s}                            
                        }
                        else
                        {
                            txtStatus.Text = "COM1 is NG(" + COM1_failNum.ToString()  + ")";
                            mainStep = 1;             //i3G Reset
                            rst3GStep = 0;                            
                        }                                         
                    }

                    Application.DoEvents();  
                    break;
                case 1:   //3G Reset 

                    //YB󼷸A,,קKUɥdbOpening Port
                    if (IsDialup)
                    {
                        RasHangUp(rc);
                        IsDialup = false;                  //B󼷸ѪA
                    }

                    switch (rst3GStep)
                    {
                        case 0:   //Power Off
                            txtStatus.Text = "3G Power Off";
                            /////////////////////////////////////////////
                            if(HardwareID().Substring(0, 4).ToLower() != "wp52")
                            {//slot0~7 8213-3gw/8214-4GW power
                                try
                                {
                                    for (int i = 0; i < 8; i++)
                                    {
                                        Sys.slot_outp(i, 8, 0x01);
                                    }
                                }
                                catch (Exception ee1) { }
                            }
                            else
                                Power3GNet.Power3GNet.pac_Control3GPower_net(false);
                            ////////////////////////////////////////////
                            rst3GStep = 1;        
                    
                            break;
                        case 1:   //10
                            txtStatus.Text = "3G Power Off : Delay 10000 ms";
                            if (DelayTime(10000)) rst3GStep =2;
                            
                            break;
                        case 2:
                            txtStatus.Text = "3G Power ON";
                            /////////////////////////////////////////////////////
                            if (HardwareID().Substring(0, 4).ToLower() != "wp52")
                            {//slot0~7 8213-3gw/8214-4GW power
                                try
                                {
                                    for (int i = 0; i < 8; i++)
                                    {
                                        Sys.slot_outp(i, 8, 0x00);//slot0~7
                                    }
                                }
                                catch (Exception ee1) { }
                            }
                            else
                                Power3GNet.Power3GNet.pac_Control3GPower_net(true);
                             /////////////////////////////////////////////
                            rst3GStep = 3;

                            break;
                        case 3:   //15
                            txtStatus.Text = "3G Power ON : Delay 15000 ms";
                            if (DelayTime(15000))
                            {
                                rst3GStep = 0;
                                mainStep = 0;    //^ˬdCOM1O_sb
                            }
                            break;                      
                    }

                    Application.DoEvents();  
                    break;
                case 2:   //Ping@ӺWIP 
                                        
                    try
                    {
                        PingState = ping(PingIP, 1000);
                        //PingState = -1;
                        if (PingState == 1)
                        {
                            Ping_successNum++;  //Ping\
                            txtStatus.Text = "Ping " + PingIP + " success at " + DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss");
                            Ping_failNum = 0;
                            Application.DoEvents();  
                        }
                        else
                        {
                            Ping_failNum++;       //PingѪ
                            txtStatus.Text = "Ping " + PingIP + " fail(" + Ping_failNum.ToString()  + ") at " + DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss");
                            Application.DoEvents();  
                        }
                    }
                    catch (System.Exception e1)
                    {                        
                        txtStatus.Text = "Ping exception : " + e1.Message;
                        Application.DoEvents(); 
                    }

                    //PingѶWL@w
                    if (Ping_failNum > FAILLIMIT.Value)
                        {
                            mainStep = 4;            //i漷                    
                            Ping_failNum = 0;     //Ѧk0                            
                        }
                        else
                        {                           
                            mainStep = 3;             //iJPing
                        }   
                 
                     //\ƶWL@wqN@
                        if (Ping_successNum > 10)
                        {
                            //\k0
                            Ping_successNum = 0;

                            //ѨMIcmpSendEcho()|ymemory leakD
                            //IntPtr ICMPHandle = IcmpCreateFile();
                            //IcmpCloseHandle(ICMPHandle);
                            //GC.Collect();

                            //txtStatus.Text = "Run IcmpCreateFile..... ";
                            //Application.DoEvents(); 
                        }

                    break;
                case 3:   //2,APing@

                    //txtStatus.Text = "Ping : Delay 2000 ms";                    
                    if (DelayTime((uint)((PINGNUM.Value-3)*1000))) mainStep = 2;    //^PingO
                   
                    Application.DoEvents();  
                    break;
                case 4:   //

                    //YB󼷸A,,קKUɥdbOpening Port
                    //wＷn骺A(connmc.exe)
                    if (IsDialup)
                    {
                        RasHangUp(rc);
                        IsDialup = false;                  //B󼷸ѪA
                    }

                    txtStatus.Text = "Ras Dial-up.....";
                    Application.DoEvents();
                    RasDialupState = myRasDial(RasName, RasAccount, RasPassword, out rc);
                    if (RasDialupState == 0)
                    {
                        txtStatus.Text = "Ras Dial-up Successfully";
                        Application.DoEvents();

                        IsDialup = true;                  //B󼷸\A
                        RasDailup_failNum = 0;     //Ѧk0
                        mainStep = 2;                    //iPing
                    }
                    else     //                     
                    {
                        IsDialup = false;                  //B󼷸ѪA
                        RasDailup_failNum++;       //Ѧ+1
                        txtStatus.Text = "Ras Dial-up Fail(" + RasDailup_failNum.ToString() + ")" + "-" + RasDialupState.ToString();
                        Application.DoEvents(); 

                        //Y\,nW귽,_h|Memory LeakD(Y@W,Memory Leakp|ܩ)
                        RasHangUp(rc);     //귽^
                                                    
                    }

                    if (RasDailup_failNum > 5) //WLYӦ
                    {
                        mainStep = 1;                //^Reset 3G
                        RasDailup_failNum = 0; //Ѧk0
                    }                    
                    
                    break;                
                case 99: //s}

                    ProcessTm.Enabled = false; 
                    Power3GNet.Power3GNet.pac_ResetSys();

                    break;

            }

            ProcessTm.Enabled = true;
        }

        //
        UInt32 DTimerEn=0;
        DateTime DTimerSt;
        DateTime DTimerEd;
        TimeSpan DiffTm;
        //return false : pɥ
        //return true : pɤw
        private bool DelayTime(UInt32 ims)
        {
            if (DTimerEn == 0)     //TimerҰ
            {
                DTimerEn = 1;
                DTimerSt = DateTime.Now;
                return false;    
            }
            else
            {
                DTimerEd=DateTime.Now;
                DiffTm = (TimeSpan)(DTimerEd - DTimerSt);
                //txtStatus.Text = DiffTm.TotalMilliseconds.ToString() ;
                if (DiffTm.TotalMilliseconds > ims)
                {
                    DTimerEn = 0;
                    return true;
                }
                else
                {                   
                    return false;
                }
            }            
        }

        private void btnRasEnum_Click(object sender, EventArgs e)
        {
            DisConnectAll();
        }
        private void SendStringToCOM(string sData)
        {
            //Console.WriteLine("SendStringToCOM");
            comPort.Write(sData);
        }
        private void timer1_Tick(object sender, EventArgs e)
        {//AT+CSQ
            try
            {
                comPort.PortName = "COM1";
                comPort.Open();
                sCmd = "AT+CSQ" + endChr;//Send GPS RMC command
                SendStringToCOM(sCmd);
            }
            catch (Exception ee)
            {
                comPort.Close();
            }
        }
        private void AddReceive(object s, EventArgs e)
        {
            string sTemp=null;
            sTemp = comPort.ReadExisting();
            //Console.WriteLine(sTemp.IndexOf(":", 0, sTemp.Length).ToString());
            //Console.WriteLine(sTemp);
            if (sTemp.IndexOf(":", 0, sTemp.Length)>0)
            {
                sTemp = sTemp.Substring(sTemp.IndexOf(":", 0, sTemp.Length) + 2, 5);
                label5.Text = sTemp;
            }
           
        }
        private void port_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            this.Invoke(new EventHandler(AddReceive));
            Thread.Sleep(500);
            comPort.Close();
        }
        private string HardwareID()
        {
            if (FindReg("HKEY_LOCAL_MACHINE\\HARDWARE\\MODULETYPE\\"))
            {
                if (GetReg("HKEY_LOCAL_MACHINE\\HARDWARE\\MODULETYPE\\HWID", 64).Length > 4)
                    return GetReg("HKEY_LOCAL_MACHINE\\HARDWARE\\MODULETYPE\\HWID", 64).Substring(0, 6);
                else
                    return GetReg("HKEY_LOCAL_MACHINE\\HARDWARE\\MODULETYPE\\HWID", 64);
            }
            else return "C270W";
        }

        #region Registry Operation
        //==================================================================       
        string GetReg(string KeyName, int Length)
        {
            string strReg = new string(' ', 256);
            PAC_Reg.RegGetString(KeyName, strReg, (uint)(Length << 2));
            return strReg;
        }

        uint GetReg(string KeyName)
        {
            uint Val = 0;
            Val = PAC_Reg.RegGetDWORD(KeyName);
            return Val;
        }

        void SetReg(string KeyName, string assignStr, int Length)
        {
            PAC_Reg.RegSetString(KeyName, assignStr, (uint)(Length << 2));
        }

        void SetReg(string KeyName, uint Val)
        {
            PAC_Reg.RegSetDWORD(KeyName, Val);
        }
        bool FindReg(string KeyName)//added by sean[08/12/11]
        {
            return PACNET.PAC_Reg.RegKeyExist(KeyName);
        }
        //==================================================================
        #endregion End Registry Operation
        /////////////////////////////////////////////////////////
    }
}